"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Singleton = void 0;
var Singleton = /** @class */ (function () {
    function Singleton(name, factory) {
        Object.defineProperty(this, "name", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "factory", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "value", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.name = name;
        this.factory = factory;
    }
    Object.defineProperty(Singleton.prototype, "provide", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function (context) {
            if (this.value)
                return this.value;
            var old = context.dependencyTracker.lastSingleton;
            context.dependencyTracker.lastSingleton = this.name;
            var value = this.factory(context.proxy);
            context.dependencyTracker.lastSingleton = old;
            return (this.value = value);
        }
    });
    Object.defineProperty(Singleton.prototype, "clone", {
        enumerable: false,
        configurable: true,
        writable: true,
        value: function () {
            return new Singleton(this.name, this.factory);
        }
    });
    return Singleton;
}());
exports.Singleton = Singleton;
